''' Doc: model user view '''
from models import BaseModel
from helpers.postgre_alchemy import postgre_alchemy as db

class UserViewModel(BaseModel, db.Model):
    """Model for the user_view table"""
    __tablename__ = 'user_view'

    # user
    id = db.Column(db.Integer, primary_key=True)
    username = db.Column(db.String(255))
    nip = db.Column(db.String(255))
    email = db.Column(db.String(255))
    name = db.Column(db.String(255))
    password = db.Column(db.String(255))
    kode_kemendagri = db.Column(db.String(255))
    kode_skpd = db.Column(db.String(255))
    kode_skpdsub = db.Column(db.String(255))
    kode_skpdunit = db.Column(db.String(255))
    profile_pic = db.Column(db.String(255))
    last_login = db.Column(db.String(255))
    notes = db.Column(db.String(255))
    cdate = db.Column(db.DateTime(True))
    cuid = db.Column(db.Integer)
    mdate = db.Column(db.DateTime(True))
    muid = db.Column(db.Integer)
    is_active = db.Column(db.Boolean)
    is_deleted = db.Column(db.Boolean)
    is_agree = db.Column(db.Boolean)
    count_notif = db.Column(db.Integer)
    agreement_id = db.Column(db.Integer)
    role_id = db.Column(db.Integer)
    jabatan_id = db.Column(db.String(255))
    satuan_kerja_id = db.Column(db.Integer)
    lv1_unit_kerja_id = db.Column(db.String(255))
    lv2_unit_kerja_id = db.Column(db.String(255))
    lv3_unit_kerja_id = db.Column(db.String(255))
    lv4_unit_kerja_id = db.Column(db.String(255))
    level_unit_kerja = db.Column(db.Integer)
    # agreement
    agreement_version = db.Column(db.String(255))
    agreement_text = db.Column(db.String(255))
    agreement_notes = db.Column(db.String(255))
    agreement_cdate = db.Column(db.DateTime(True))
    agreement_cuid = db.Column(db.Integer)
    agreement_is_active = db.Column(db.Boolean)
    agreement_is_deleted = db.Column(db.Boolean)
    agreement_mdate = db.Column(db.DateTime(True))
    agreement_muid = db.Column(db.Integer)
    # skpd
    skpd_id = db.Column(db.Integer)
    skpd_title = db.Column(db.String(255))
    skpd_kode_skpd = db.Column(db.String(255))
    skpd_nama_skpd = db.Column(db.String(255))
    skpd_nama_skpd_alias = db.Column(db.String(255))
    skpd_logo = db.Column(db.String(255))
    skpd_description = db.Column(db.String(255))
    skpd_address = db.Column(db.String(255))
    skpd_phone = db.Column(db.String(255))
    skpd_email = db.Column(db.String(255))
    skpd_regional_id = db.Column(db.String(255))
    skpd_count_dataset = db.Column(db.Integer)
    skpd_count_dataset_public = db.Column(db.Integer)
    skpd_count_indikator = db.Column(db.Integer)
    skpd_count_indikator_public = db.Column(db.Integer)
    skpd_count_infographic = db.Column(db.Integer)
    skpd_count_infographic_public = db.Column(db.Integer)
    skpd_count_visualization = db.Column(db.Integer)
    skpd_count_visualization_public = db.Column(db.Integer)
    skpd_is_deleted = db.Column(db.Boolean)
    skpd_is_external = db.Column(db.Boolean)
    skpd_is_opendata = db.Column(db.Boolean)
    skpd_is_satudata = db.Column(db.Boolean)
    skpd_is_satupeta = db.Column(db.Boolean)
    skpd_media_facebook = db.Column(db.String(255))
    skpd_media_instagram = db.Column(db.String(255))
    skpd_media_twitter = db.Column(db.String(255))
    skpd_media_website = db.Column(db.String(255))
    skpd_media_youtube = db.Column(db.String(255))
    # skpd sub
    skpdsub_id = db.Column(db.Integer)
    skpdsub_kode_skpd = db.Column(db.String(255))
    skpdsub_kode_skpdsub = db.Column(db.String(255))
    skpdsub_nama_skpd = db.Column(db.String(255))
    skpdsub_nama_skpdsub = db.Column(db.String(255))
    skpdsub_skpd_id = db.Column(db.Integer)
    # skpd unit
    skpdunit_id = db.Column(db.Integer)
    skpdunit_kode_skpd = db.Column(db.String(255))
    skpdunit_kode_skpdsub = db.Column(db.String(255))
    skpdunit_kode_skpdunit = db.Column(db.String(255))
    skpdunit_nama_skpd = db.Column(db.String(255))
    skpdunit_nama_skpdsub = db.Column(db.String(255))
    skpdunit_nama_skpdunit = db.Column(db.String(255))
    skpdunit_skpdsub_id = db.Column(db.Integer)
    # role
    role_name = db.Column(db.String(255))
    role_title = db.Column(db.String(255))
    role_notes = db.Column(db.String(255))
    # struktur ogranisasi
    struktur_organisasi_id = db.Column(db.Integer)
    struktur_organisasi_satuan_kerja_nama = db.Column(db.String(255))
    struktur_organisasi_lv1_unit_kerja_nama = db.Column(db.String(255))
    struktur_organisasi_lv2_unit_kerja_nama = db.Column(db.String(255))
    struktur_organisasi_lv3_unit_kerja_nama = db.Column(db.String(255))
    struktur_organisasi_lv4_unit_kerja_nama = db.Column(db.String(255))
    struktur_organisasi_level = db.Column(db.String(255))
    struktur_organisasi_parent_id = db.Column(db.String(255))
    struktur_organisasi_jabatan_nama = db.Column(db.String(255))
    struktur_organisasi_eselon_id = db.Column(db.String(255))
    struktur_organisasi_eselon_nm = db.Column(db.String(255))
    struktur_organisasi_gol_id_minimum = db.Column(db.String(255))
    struktur_organisasi_kode_skpd = db.Column(db.String(255))
    # jabatan
    jabatan_nama = db.Column(db.String(255))
    satuan_kerja_nama = db.Column(db.String(255))
    lv1_unit_kerja_nama = db.Column(db.String(255))
    lv2_unit_kerja_nama = db.Column(db.String(255))
    lv3_unit_kerja_nama = db.Column(db.String(255))
    lv4_unit_kerja_nama = db.Column(db.String(255))
    # dash_role
    dash_role_id = db.Column(db.Integer)
    dash_role_name = db.Column(db.String(255))
    dash_role_title = db.Column(db.String(255))
    dash_role_notes = db.Column(db.String(255))


def __init__(self, name):
    self.name = name
